####################################################################################
#Author: Zhang Tao
#Email: zhangtao@cryst.iphy.ac.cn
#Created time: 2008,05,20
#last Edit: 2008,05,20
#Group: SM5,  The Institute of Physics, Chinese Academy of Sciences
#####################################################################################

######parameters##################################################
#1: parameters pool
#2: changed parameters pool
#3: states pool
###################################################################################

source $1
source $2

echo "set build_status = 0" >> $3

set arp_csh = ${name_c}_arp.csh
set arp_par = ${name_c}_arp.par
rm -f $arp_csh
rm -f $arp_par
touch  $arp_csh
touch  $arp_par
##prepare parameter' file
echo "set seqin = $seqin " >> $arp_par
echo "set REF_MODE = $REF_MODE " >> $arp_par
echo "set EXCLUDE_FREER = $EXCLUDE_FREER " >> $arp_par
echo "set sym = $sym " >> $arp_par
echo "set cell = '$CELL_A  $CELL_B  $CELL_C $CELL_ALPHA $CELL_BETA $CELL_GAMMA'" >> $arp_par
echo "set cgr = $cgr " >> $arp_par
echo "set ncs_num = $ncs_num " >> $arp_par


if ( $IF_ARP7 == 1 ) then
  echo "set whichtrace = 1 " >> $arp_par
else
  echo "set whichtrace = 0 " >> $arp_par
endif
echo "set scale = $SCALE" >> $arp_par
if ( $OASIS_MODE == EXT ) then
set datafile = "$oasis_hklin"
echo "set hl_signal = 0" >> $arp_par
#echo "set modelin = ../../$init_pdb " >> $arp_par
echo "set modelin = $start_pdb " >> $arp_par
echo "set phibest = PHIC " >> $arp_par
echo "set fom =  " >> $arp_par
echo "set modeccp4i = WARPNTRACEMODEL "  >> $arp_par
echo "set fp = $FP" >> $arp_par
echo "set sigfp = $SIGFP" >>  $arp_par
echo "set fbest = $FP" >> $arp_par
else
echo "set fp = FP" >> $arp_par
echo "set sigfp = SIGFP" >>  $arp_par
echo "set fbest = FP" >> $arp_par
set datafile = "../$last_out"
echo "set modeccp4i = WARPNTRACEPHASES "  >> $arp_par
echo "set modelin = '' " >> $arp_par
echo "set phibest = $phi " >> $arp_par
echo "set fom = $fom " >> $arp_par
echo "set hl_signal = $hl_signal" >> $arp_par
if ( $hl_signal == 1 ) then
  echo "set HLA = $HLA" >> $arp_par
  echo "set HLB = $HLB" >> $arp_par
  echo "set HLC = $HLC" >> $arp_par
  echo "set HLD = $HLD" >> $arp_par
endif
endif


echo "set main_path = .. " >> $arp_par

echo "set datafile = $datafile " >> $arp_par
echo "set seq_num = $seq_num " >> $arp_par
echo "set name_c = $name_c " >> $arp_par
echo "set arp_select_mode = $arp_select_mode " >> $arp_par
if ( "DMR" == $OASIS_MODE ) then
  echo "set select_mode = $select_mode" >> $arp_par
else
  echo "set select_mode = null" >> $arp_par
endif
echo "set arp_select_mode = $arp_select_mode " >> $2
##script file
echo "#\!/bin/tcsh" >>  $arp_csh
echo " if ( -e ${name_c}_arp_tmp ) then " >> ${name_c}_arp.csh
echo "echo 'A ARP/wARP is running now, please check .${name_c}_resolve_tmp and remove it'" >> ${name_c}_arp.csh
echo "else" >> ${name_c}_arp.csh
echo "mkdir ${name_c}_arp_tmp"  >> ${name_c}_arp.csh
echo "cd ${name_c}_arp_tmp" >> ${name_c}_arp.csh
if ( $OASIS_MODE != "EXT" ) then
  if ( $RFREE != 'Unassigned' ) then
    echo "$CBIN/cad HKLIN1 ../$last_out  HKLIN2 $hklin_free  HKLOUT  ${name_c}_rfree.mtz << +" >> ${name_c}_arp.csh
    echo "LABIN FILE 1 ALL" >> ${name_c}_arp.csh
    echo "LABIN FILE 2 E1=$RFREE" >> ${name_c}_arp.csh
    echo "+" >> ${name_c}_arp.csh
    echo "set RFREE = $RFREE " >> $arp_par
  else
    echo "$CBIN/freerflag HKLIN ../$last_out HKLOUT ${name_c}_rfree.mtz << + " >> ${name_c}_arp.csh
    echo "+" >> ${name_c}_arp.csh
    echo "set RFREE = 'FreeR_flag' " >> $arp_par
  endif
  echo "set datafile = ' ./${name_c}_rfree.mtz ' " >> $arp_par
else
  if ( $RFREE == 'Unassigned' ) then
    echo "$CBIN/freerflag HKLIN $oasis_hklin HKLOUT ${name_c}_rfree.mtz << +" >> ${name_c}_arp.csh
    echo "+" >> ${name_c}_arp.csh
    echo "set RFREE = 'FreeR_flag' " >> $arp_par
    echo "set datafile = ' ./${name_c}_rfree.mtz ' " >> $arp_par
  else
    echo "set RFREE = $RFREE " >> $arp_par
  endif
endif
set version = `$warpbin/arp_warp -v`
if ( $version  == "61022804" ) then
  echo "${oasisbin}/arp_warp6.sh ../$arp_par " >> ${name_c}_arp.csh
else if ( $version  == "70310107" ) then
  echo "${oasisbin}/arp_warp7.sh ../$arp_par " >> ${name_c}_arp.csh
else if ( $version  == "701210907" ) then
  echo "${oasisbin}/arp_warp71.sh ../$arp_par " >> ${name_c}_arp.csh
endif
echo "cd -" >> ${name_c}_arp.csh
echo "rm -fr ${name_c}_arp_tmp" >> ${name_c}_arp.csh
echo "endif" >> ${name_c}_arp.csh

#execute csh
if ( -e ${name_c}_arp_tmp ) then
  rm -fr ${name_c}_arp_tmp
endif
chmod +x $arp_csh
./$arp_csh

echo "set build_pro = arp" >> $2

if ( -e ${name_c}_result.par  ) then
  echo "set build_status = 1" >> $3
else
  echo "set build_status = 0" >> $3
  exit
endif

source ${name_c}_result.par
if ( $arp_select_mode == "normal" ) then
	echo "set build_pdb_out = ${name_c}_arp.pdb" >> $2
	echo "set build_mtz_out = ${name_c}_arp.mtz" >> $2
	echo "set resulte = ( ${recommend[1]} ${recommend[2]}  ${recommend[3]} ${recommend[4]} )" >> $2
else if ( $arp_select_mode == "dbest" ) then
	echo "set build_pdb_out = ${name_c}_arp_dres.pdb" >> $2
	echo "set build_mtz_out = ${name_c}_arp_dres.mtz" >> $2
	echo "set  resulte = ( ${dock_best[1]} ${dock_best[2]} ${dock_best[3]} ${dock_best[5]} ) " >> $2
else if ( $arp_select_mode == "cbest" ) then
	echo "set build_pdb_out = ${name_c}_arp_cres.pdb" >> $2
	echo "set build_mtz_out = ${name_c}_arp_cres.mtz" >> $2
	echo "set  resulte = ( ${res_best[1]} ${res_best[2]} ${res_best[3]} ${res_best[5]} ) " >> $2
else if ( $arp_select_mode == "rbest" ) then
	echo "set build_pdb_out = ${name_c}_arp_r.pdb" >> $2
	echo "set build_mtz_out = ${name_c}_arp_r.mtz" >> $2
	echo "set  resulte = ( ${r_best[1]} ${r_best[2]} ${r_best[3]} ${r_best[5]} ) " >> $2
else if ( $arp_select_mode == "rfree" ) then
	echo "set build_pdb_out = ${name_c}_arp_rfree.pdb" >> $2
	echo "set build_mtz_out = ${name_c}_arp_rfree.mtz" >> $2
	echo "set  resulte = ( ${rfree_best[1]} ${rfree_best[2]} ${rfree_best[3]} ${rfree_best[5]} ) " >> $2
endif
echo "set build_frc_out = ${name_c}_arp.frc" >> $2
source $2
cat ${name_c}_result.par >> $2
rm -f ${name_c}_result.par
if ( $OASIS_MODE == EXT ) then
  echo "set build_fp = $FP " >> $2
  echo "set build_sigfp = $SIGFP " >> $2
else
  echo "set build_fp = FP " >> $2
  echo "set build_sigfp = SIGFP " >> $2
endif
echo "set fom_signal = 1"  >> $2
echo "set FOMM = FOM" >> $2
echo "set fom_file = $build_mtz_out "  >> $2
#echo "set hl_signal = 0 " >> $2
echo "set fof_signal = 1 "  >> $2

${CBIN}/coordconv XYZIN $build_pdb_out \
XYZOUT ${name_c}_tmp.ha  << + > ${name_c}_frc.log
	input PDB -
       orth 1
       output HA
       cell $CELL_A $CELL_B $CELL_C $CELL_ALPHA $CELL_BETA $CELL_GAMMA 
       end
+




awk  -v dum="$IF_DUM" 'BEGIN{n=0} {n++;c= toupper(substr($2,1,1));c_ha = toupper(substr($2,1,2)) ;if ( c!="C" && c!="N" && c!="O" && c!="S" && c!="D"  ||  c_ha=="SE" || c_ha=="CU"  ) { c=c_ha;} else if ( c =="D" )  {if ( dum == "0" ) { c="C";} else {next;};} printf "%s %d %.4f %.4f %.4f %.4f %.4f \n",c,n,$3,$4,$5,$6,$9;}' ${name_c}_tmp.ha > $build_frc_out

rm -f ${name_c}_tmp.ha

#if ( "1" == $ha_signal )  then
#	set ii = 1
#	set par_n = `awk 'BEGIN{n=0;} {n++} END{print n;}' $oasis_frc `
#	while ( $ii <= $HA_NUM )
#		@ par_n++
#		echo "$HA_TYPE[$ii] $par_n $HA_X[$ii] $HA_Y[$ii] $HA_Z[$ii] $HA_OCC[$ii] $HA_B[$ii]" >> $build_frc_out
#		@ ii++
#	end
#endif

