####################################################################################
#Author: Zhang Tao
#Email: zhangtao@cryst.iphy.ac.cn
#Created time: 2008,05,19
#last Edit: 2008,05,19 
#Group: SM5,  The Institute of Physics, Chinese Academy of Sciences
#####################################################################################

######parameters##################################################
#1: parameters pool
#2: changed parameters pool
#3: states pool
###################################################################################

source $1
source $2

echo "set dm_status = 0" >> $3


set dm_csh = ${name_c}_dm.csh
rm -f $dm_csh
touch  $dm_csh
#dm command
echo "${CBIN}/dm HKLIN  $phase_out HKLOUT ${name_c}_dm.mtz << +" >> $dm_csh

#dm script
echo	"combine PERT" >> $dm_csh
echo	"scheme ALL" >> $dm_csh
echo	"ncycles AUTO" >> $dm_csh
echo	"solc $SOLC" >> $dm_csh


if ( ${fof_signal} == 1 ) then
	echo -n "LABIN  FP=$FOF SIGFP=SIGFP PHIO=$phase_phi FOMO=$phase_fom" >> $dm_csh
else
	echo -n "LABIN  FP=FP SIGFP=SIGFP PHIO=$phase_phi FOMO=$phase_fom" >> $dm_csh
endif

if ( $hl_signal == 1 ) then 
  echo " HLA=$HLA HLB=$HLB HLC=$HLC HLD=$HLD " >> $dm_csh
else
  echo " "   >> $dm_csh
endif

if ( $ncs_signal == 1 ) then
echo	"mode SOLV AVER" >> $dm_csh
echo "ncsmask size 3" >> $dm_csh
set ncs_line = ` awk 'BEGIN{n=0;} /Transformations formatted for input to resolve:/{n++;} END{print n;}' $ncs_file`
awk -v line="$ncs_line" 'BEGIN{ m_n=0;n=0;} /rota_matrix|tran_orth|Transformations formatted for input to resolve:/{if ( $1 == "Transformations" ) {n++;next;} if ( n==line ) { if( m_n == 0) { printf"average REFI \n rota MATRIX - \n  %.4f  %.4f  %.4f - \n",$2,$3,$4;m_n++;next} if ( m_n == 1) {printf"  %.4f  %.4f  %.4f - \n",$2,$3,$4;m_n++;next}if ( m_n == 2) {printf"  %.4f  %.4f  %.4f \n",$2,$3,$4;m_n++;next;}if ( $1 == "tran_orth") {printf"tran  %.4f  %.4f  %.4f\n",$2,$3,$4; m_n=0;}}}' $ncs_file >> $dm_csh
else
echo	"mode SOLV" >> $dm_csh
echo	"ncsmask" >> $dm_csh
endif

echo		"LABOUT  FDM=FDM PHIDM=PHIDM FOMDM=FOMDM" >> $dm_csh
echo		"RSIZE 80" >> $dm_csh
echo "+" >> $dm_csh


#execute csh
chmod +x $dm_csh
./$dm_csh

if ( $status != 1 ) then
echo "set dm_status = 1" >> $3
else
echo "set dm_status = 0" >> $3
endif


echo "set dm_phi = PHIDM  " >> $2
echo "set dm_fom = FOMDM  " >> $2
echo "set dm_out = ${name_c}_dm.mtz " >> $2
echo "set phi = PHIDM  " >> $2
echo "set fom = FOMDM  " >> $2
echo "set last_out = ${name_c}_dm.mtz " >> $2
echo "set dm_pro = dm" >> $2


