#!/bin/tcsh 
####################################################################################
#Author: Zhang Tao
#Email: zhangtao@cryst.iphy.ac.cn
#Created time: 2008,09,14
#last Edit: 2008,09,14
#Group: SM5,  The Institute of Physics, Chinese Academy of Sciences
#####################################################################################

######parameters##################################################
#1 main parameters
###################################################################################

source $1

cd $path_c

if ( $OASIS_MODE == "DMR" ) then

  if ( $phase_signal != "oasis" || $extend_model_signal == 1 ) then
    set i = 0
  else
    set i = 1
  endif
  rm -fr $html_name/interface_${i}.htm
  if ( $i == 0 ) then
     if ( -e .par_tmp/mr_${i}_1.par ) then
       source .par_tmp/mr_${i}_1.par
       source $stat_file
       $oasisbin/html/show.csh .par_tmp/mr_${i}_1.par $stat_file 0 interface_${i}.htm $mr_states 1
       set mr_signal = 1
     else
       set mr_signal = 0 
     endif
   @ i ++
   endif
    while($i <= ${cyc_num})
      if ( $i == 1 ) then
        @ s = 1 + $skip_num
        set srange = $first_seed
      else
        @ s = 1
        set srange = ${seed_range}
      endif
      rm -fr $html_name/interface_${i}.htm
      while ( $s <= ${srange} )
        if ( -e .par_tmp/mr_${i}_${s}.par ) then
          source .par_tmp/mr_${i}_${s}.par
          source $stat_file
          $oasisbin/html/show.csh .par_tmp/mr_${i}_${s}.par $stat_file $i interface_${i}.htm $mr_states $s
          set mr_signal = 1
        else
          set mr_signal = 0 
        endif
        @ s++
      end
    if ( $mr_signal == 0 ) break
    $oasisbin/html/show_select.csh 1 $best_seed .par_tmp/mr_${i}_${best_seed}.par ${srange} interface_${i}.htm 
    @ i++
    end
else

  if ( $PAR == "0" ) then
    set i = 0
  else
    set i = 1
  endif
  while( $i <= ${cyc_num} )
    rm -fr $html_name/interface_${i}.htm
    if ( -e .par_tmp/sad_${i}.par ) then
      source .par_tmp/sad_${i}.par
      source $stat_file
      $oasisbin/html/show.csh .par_tmp/sad_${i}.par $stat_file $i interface_${i}.htm $sad_states
      @ i++
    else
      @ i--
      break
    endif
  end
endif
source ${oasisbin}/html/info.csh > ${path_c}/$html_name/info.htm
${oasisbin}/html/interface.csh  ${path_c}/$html_name/.inter.par $id

