#!/bin/tcsh 
####################################################################################
#Author: Zhang Tao
#Email: zhangtao@cryst.iphy.ac.cn
#Created time: 2008,09,14
#last Edit: 2008,09,14
#Group: SM5,  The Institute of Physics, Chinese Academy of Sciences
#####################################################################################

######parameters##################################################
#1: parameters pool
#2: number of cycles
###################################################################################
source $1
if ( $2 < 5 ) then
  set cyc_num_tmp = 5
else
  @ cyc_num_tmp = $2 + 1
endif
if ( !(-e $pic_data_file) ) then
  set plot_command = " 0 notitle with lines linetype 0 linewidth 0"
else
  set plot_command = ""
  set signal1 = `awk -v n=7 'BEGIN{ signal = 0;}{if ($n!="null"){signal =1;}} END{print signal;}' $pic_data_file`
    if ( $signal1 == 1 ) then
      set plot_command = "$plot_command '$pic_data_file' u 1:7 notitle  with linespoints pointtype 10 pointsize 1 linetype 6 linewidth 2 lc rgb '#00fdf4',"
    endif

  set signal2 = `awk -v n=6 'BEGIN{ signal = 0;}{if ($n!="null"){signal =1;}} END{print signal;} ' $pic_data_file`
    if ( $signal2 == 1 ) then
      set plot_command = "$plot_command '$pic_data_file' u 1:6 notitle  with linespoints pointtype 10 pointsize 1 linetype 5 linewidth 2 lc rgb '#06f81d',"
    endif

  set signal3 = `awk -v n=5 'BEGIN{ signal = 0;}{if ($n!="null") {signal =1;}} END{print signal;}' $pic_data_file`
    if ( $signal3 == 1 ) then
      set plot_command = "$plot_command '$pic_data_file' u 1:5 notitle   with linespoints pointtype 10 pointsize 1 linetype 4 linewidth 2 lc rgb '#5aaaaa',"
    endif

  set signal4 = `awk -v n=4 'BEGIN{ signal = 0;}{if ($n!="null"){signal =1;}} END{print signal;}' $pic_data_file`
    if ( $signal4 == 1 ) then
      set plot_command = "$plot_command '$pic_data_file' u 1:4 notitle   with linespoints pointtype 10 pointsize 1 linetype 3 linewidth 2 lc rgb '#0000ff' ,"
   endif

  set plot_command = "$plot_command '$pic_data_file' u 1:2 title 'residues buildt'   with linespoints pointtype 10 pointsize 1 linetype 1 linewidth 2 lc rgb '#f8cf6a'"

  set plot_command = "$plot_command ,'$pic_data_file' u 1:3 title '   residues placed'  with linespoints pointtype 10 pointsize 1 linetype 2 linewidth 2 lc rgb '#ff0000'"

    if ( $signal2 == 1 ) then
      set plot_command = "$plot_command, -100 title 'resolve score'  with linespoints pointtype 10 pointsize 1 linetype 5 linewidth 2 lc rgb '#06f81d' "
    endif

    if ( $signal1 == 1 ) then
      set plot_command = "$plot_command, -100 title 'map CC   '  with linespoints pointtype 10 pointsize 1 linetype 6 linewidth 2 lc rgb '#00fdf4' "
    endif


    if ( $signal4 == 1 ) then
      set plot_command = "$plot_command, -100 title '     R factor'   with linespoints pointtype 10 pointsize 1 linetype 3 linewidth 2 lc rgb '#0000ff'"
   endif
  
    if ( $signal3 == 1 ) then
      set plot_command = "$plot_command, -100 title 'Rfree factor'   with linespoints pointtype 10 pointsize 1 linetype 4 linewidth 2 lc rgb '#5aaaaa' "
    endif




endif



$oasisbin/gnuplot << end
set xtics nomirror
unset x2tics
set xrange [0:$cyc_num_tmp]
set yrange [0:1]  
set xtics 1
set ytics ("0" 0, "10%%" 0.1 ,"20%%" 0.2 ,"30%%" 0.3,"40%%" 0.4 ,"50%%" 0.5,"60%%" 0.6 ,"70%%" 0.7,"80%%" 0.8,"90%%" 0.9,"100%%" 1 )
set ytics nomirror
set y2tics ("0" 0, "0.1" 0.142857 ,"0.2" 0.285714 ,"0.3" 0.428571,"0.4" 0.571428 ,"0.5" 0.714285,"0.6" 0.857142 ,"0.7" 1)
set key below width -3 
set grid
set ylabel "Percentage of residues\n Map CC" 
set y2label "R value" 
set xlabel "number of cycle"
set terminal png  size 870 390 
set output "$pic_file"   
plot $plot_command
end
