#!/bin/tcsh 
####################################################################################
#Author: Zhang Tao
#Email: zhangtao@cryst.iphy.ac.cn
#Created time: 2008,05,20
#last Edit: 2008,05,20
#Group: SM5,  The Institute of Physics, Chinese Academy of Sciences
#####################################################################################

######parameters##################################################
#1: parameters pool
#2: changed parameters pool
#3: states pool
#4: dm signal
###################################################################################



set pid = `$oasisbin/get_id.csh main.csh`
echo "set pid = $pid  " >> $1

# Sourcing the parameter file
echo 'The parameter file is:' $1
source $1

#set path_c = `echo $hklout | awk '{n=split($1,p,"/");for(i=1;i<n;i++) {printf"%s/",p[i];};printf"oasis"}'`
set name = `echo $hklout | awk '{n=split($1,file_name,"/");split(file_name[n],top,".");split(top[1],name,"_");print name[1];}'`


if ( $continue_signal == 0 ) then
  rm -fr $main_path
endif

set path_c = "$main_path/auto_oasis_data"
echo "set path_c = $path_c " >> $1
echo "set name = $name  " >> $1

if ( !(-e $main_path) ) then
  mkdir $main_path
  mkdir $path_c
endif
cd $path_c
set main_par = $1
@ id = 0
@ s = 1 + $skip_num
  


set main_stat = .par_tmp/main.sta
if ( -e $main_stat ) then
  source $main_stat
else
  rm -fr ${path_c}/.par_tmp
  mkdir ${path_c}/.par_tmp
  cp $main_par ${path_c}/.par_tmp/par
  rm -fr ${path_c}/$html_name
  mkdir ${path_c}/$html_name
  touch $main_stat
  set i = `${oasisbin}/prepare.csh $main_par`
  echo "set i = $i " >> ${main_stat}
  source $main_par
  cp ${oasisbin}/html/index.htm ${oasisbin}/html/view_job.csh  ${path_c}/$html_name/
  cp ${oasisbin}/html/index2.htm ${oasisbin}/html/do_re_show.csh  ${path_c}/$html_name/
  cp ${oasisbin}/html/oasis.js  ${path_c}/$html_name/
  cp ${oasisbin}/html/view_pdb.csh ${path_c}/$html_name/
  cp ${oasisbin}/html/terminate.csh  ${path_c}/$html_name/
  cp ${oasisbin}/html/PyMOL.gif  ${path_c}/$html_name/
  source ${oasisbin}/html/info.csh > ${path_c}/$html_name/info.htm
  echo "stime='`date +'%k:%M %B %d %Y'`'" > ${path_c}/$html_name/.inter.par
  echo "html_name=$html_name " >>  ${path_c}/$html_name/.inter.par
  echo "info=$html_name/info.htm " >>  ${path_c}/$html_name/.inter.par
  $oasisbin/html/show_pic.csh $1 $i
endif

#prepare the html
${oasisbin}/html/interface.csh  ${path_c}/$html_name/.inter.par $id
${oasisbin}/html/show_control.csh $1 $i 0 
cd $main_path
  ln -s auto_oasis_data/0_html/index.htm index.htm
cd -
if ( `uname` == 'Linux' ) then
  firefox ${path_c}/$html_name/index.htm&
else if ( `uname` == 'Darwin' ) then
  open ${path_c}/$html_name/index.htm&
endif
while( ${i} <= ${cyc_num} )
  set interface_name = "interface_${i}.htm"
  if ( ${OASIS_MODE} == 'DMR' ) then
    if ( ${i} == "0" ) then
       set mr_par = .par_tmp/mr_${i}_1.par
       if ( !(-e ${mr_par}) ) then
         touch ${mr_par}
         @ id++
         echo "set id = $id " >> $mr_par
         echo "set id = $id " >> ${main_stat}
       endif
       if ( $phase_signal == "oasis" ) then
         ${oasisbin}/extend_model.csh ${main_par} ${main_stat} $interface_name ${mr_par}
       else
         ${oasisbin}/mr.csh ${main_par} $i ${main_stat} ${mr_par}  $s $interface_name
       endif
       ${oasisbin}/get_best_seed.csh $i 1 $1
       echo "i[$i]=interface_${i}.htm" >> $html_name/.inter.par
       source ${main_stat}
       if ( $mr_states == 0 ) goto exitlab 
       set last_par = $mr_par
       echo "set last_par = $last_par " >> ${main_stat}
       @ i++
       echo "set i = $i " >> ${main_stat}
       ${oasisbin}/output_result.csh $1 $last_par $i
       ${oasisbin}/html/interface.csh  ${path_c}/$html_name/.inter.par $id
       continue
    else
      if ( $i == 1 && $first_signal == 1 ) then
        set srange = $first_seed
      else
        set srange = ${seed_range}
      endif
      while( ${s} <= ${srange} )
       echo "s[interface_${i}]=${s}" >> $html_name/.inter.par
       set mr_par = .par_tmp/mr_${i}_${s}.par
       if ( !(-e ${mr_par}) ) then
         touch ${mr_par}
         @ id++
         echo "set id = $id " >> $mr_par
         echo "set id = $id " >> ${main_stat}
       endif

       if ( $?last_par == 0  ) then
         ${oasisbin}/mr.csh ${main_par} $i ${main_stat} ${mr_par} $s $interface_name
       else
         ${oasisbin}/mr.csh ${main_par} $i ${main_stat} ${mr_par} $s  $interface_name $last_par
       endif
       if ( -e .par_tmp/oasis.fin ) goto stop
       @ s++
       echo "set s = $s " >> ${main_stat}
       echo "i[$i]=interface_${i}.htm" >> $html_name/.inter.par
       ${oasisbin}/html/interface.csh  ${path_c}/$html_name/.inter.par $id
     end
     set best_seed = `${oasisbin}/get_best_seed.csh $i ${seed_range} $1 $skip_num`
     if ( $best_seed == "null" ) then
       goto exitlab
     endif
     set last_par = .par_tmp/mr_${i}_${best_seed}.par
     @ id++
#	echo "set id = $id " >> $mr_par
     echo "set id = $id " >> ${main_stat}
     ${oasisbin}/html/show_select.csh $id $best_seed $last_par ${seed_range} ${interface_name} 
     echo "i[$i]=interface_${i}.htm" >> $html_name/.inter.par
     ${oasisbin}/html/interface.csh  ${path_c}/$html_name/.inter.par $id
     echo "set last_par = $last_par " >> ${main_stat}
     echo "set best_seed = $best_seed " >> $last_par
    endif
  else
    set sad_par = .par_tmp/sad_${i}.par
    if ( !(-e ${sad_par}) ) then
      touch ${sad_par}
      @ id++
      echo "set id = $id " >> $sad_par
      echo "set id = $id " >> ${main_stat}
    endif
    if ( $?last_par == 0 ) then
      ${oasisbin}/sad.csh ${main_par} $i ${main_stat} ${sad_par} $interface_name
    else
      ${oasisbin}/sad.csh ${main_par} $i ${main_stat} ${sad_par} $interface_name $last_par
    endif
    source ${main_stat}
    echo "i[$i]=interface_${i}.htm" >> $html_name/.inter.par
    ${oasisbin}/html/interface.csh  ${path_c}/$html_name/.inter.par $id
    if ( -e .par_tmp/oasis.fin ) goto stop
    if ( $sad_states == 0 ) then
      goto exitlab
    else
      set last_par = .par_tmp/sad_${i}.par
      echo "set last_par = $last_par " >> ${main_stat}
    endif
  endif
  ${oasisbin}/output_result.csh $1 $last_par $i
  ${oasisbin}/html/interface.csh  ${path_c}/$html_name/.inter.par $id
  if ( -e .par_tmp/change.par ) then
    set OASIS_MODE=`${oasisbin}/change_par.csh .par_tmp/change.par $last_par`
    source .par_tmp/change.par
  endif
  ${oasisbin}/html/show_control.csh $1 $i 1 $last_par
  @ i++
  @ s = 1
  echo "set s = $s " >> ${main_stat}
  echo "set i = $i " >> ${main_stat}
end


stop:
source $main_par
rm -f $sigma_file
echo "etime='`date +'%k:%M %B %d %Y'`'" >> ${path_c}/$html_name/.inter.par
${oasisbin}/html/interface.csh  ${path_c}/$html_name/.inter.par $id
echo ' The AUTO_OASIS terminate normally'
exit

exitlab:
echo "etime='`date +'%k:%M %B %d %Y'`'" >> ${path_c}/$html_name/.inter.par
${oasisbin}/html/interface.csh  ${path_c}/$html_name/.inter.par $id
source ${main_stat}
echo ' The AUTO_OASIS terminate abnormally'
echo " You can look for error message at file : $erorr_log"
exit

