####################################################################################
#Author: Zhang Tao
#Email: zhangtao@cryst.iphy.ac.cn
#Created time: 2008,05,19
#last Edit: 2008,05,19 
#Group: SM5,  The Institute of Physics, Chinese Academy of Sciences
#####################################################################################

######parameters##################################################
#1: parameters pool
#2: changed parameters pool
#3: states pool
#4: number of cycles
#5: number of seed
###################################################################################
source $1
source $2
echo "set phase_status = 0" >> $3
set oasis_csh = ${name_c}_oasis.csh
rm -fr  $oasis_csh
touch  $oasis_csh


#oasis command
echo -n  "${oasisbin}/oasis4-0 HKLIN $oasis_hklin HKLOUT ${name_c}_oasis.mtz " >> $oasis_csh

if ( ${PAR} == '1' || $4 > 0 ) then
	echo  "\" >> $oasis_csh
	echo -n "frcin $oasis_frc " >> $oasis_csh
endif

#if ( ${sigma_signal} == 1 && (-e $sigma_file) ) then
#  echo -n "sigin $sigma_file" >> $oasis_csh
#else
#  rm -f $sigma_file
#  echo -n "sigout $sigma_file" >> $oasis_csh
#endif

echo "<<+" >> $oasis_csh

# oasis script
echo "TIT $TIT" >> $oasis_csh

if ( $RES == "1" ) then	
echo "LIM $RESOLUTION_MIN $RESOLUTION_MAX" >> $oasis_csh
endif

if (  "DMR" == $OASIS_MODE ) then
	echo "NHA $NHA" >> $oasis_csh
	echo "SED $5" >> $oasis_csh
endif

set lab = "LABIN " 

if ( "SAD" == $OASIS_MODE )  then
  if ( $MAP_FM == "1" )  then 
	set lab = "${lab} FP=$FP SIGFP=$SIGFP DANO=$DANO SIGDANO=$SIGDANO" 
   else 
	set lab = "${lab} F(+)=$FPP SIGF(+)=$SIGFPP F(-)=$FPN SIGF(-)=$SIGFPN" 
  endif
endif

if ( "SIR" == $OASIS_MODE ) then
set lab = "${lab} FP=$FP SIGFP=$SIGFP FPH=$FPH SIGFPH=$SIGFPH" 
endif

if ( "DMR" == $OASIS_MODE ) then 
    set lab = "${lab} FP=$FP SIGFP=$SIGFP" 
endif

if ( $COMPARE_PHI ) then 
set lab = "${lab} PHIC=$PHIC"
endif
echo $lab >> $oasis_csh

set con = "CON C $OASIS_NS_C N $OASIS_NS_N O $OASIS_NS_O"
if ( $OASIS_NS_S != "0" )  set con = "${con} S $OASIS_NS_S" 
if ( $se_signal == "1" ) then
if ( $OASIS_NS_SE != "0" )  set con = "${con} SE $OASIS_NS_SE" 
endif
set ii = 1
if ( "1" == $ha_signal )  then

while ( $ii <= $HA_T_NUM )
	if ( "S" == $HA_T_TYPE[$ii] ||  "SE" == $HA_T_TYPE[$ii] && $se_signal == 1  ) then
	@ ii++
	continue
	endif
	set con = "${con}  $HA_T_TYPE[$ii]  $HA_T_TYPE_NUM[$ii]"
	@ ii++
end
endif
echo $con >> $oasis_csh

if ( "SAD" == $OASIS_MODE )  then
	set ii = 1
	while ( $ii <= $HA_T_NUM )
		if ( $ii == "1" ) then 
		echo "ANO $HA_T_TYPE[$ii] $ANO[$ii]" >> $oasis_csh
		else
		echo "    $HA_T_TYPE[$ii] $ANO[$ii]" >> $oasis_csh
		endif
		@ ii++
	end
endif

if ( "1" == $ha_signal )  then
	if ( "DMR" == $OASIS_MODE ) then
	if ( $4 > 0 ) then
		set ii = 1
		set par_n = `awk 'BEGIN{n=0;} {n++} END{print n;}' $oasis_frc `
		while ( $ii <= $HA_NUM )
			@ par_n++
			echo "$HA_TYPE[$ii] $par_n $HA_X[$ii] $HA_Y[$ii] $HA_Z[$ii] $HA_OCC[$ii] $HA_B[$ii]" >> $oasis_frc
			@ ii++
		end
	endif
	else
		set ii = 1
		echo "POS" >> $oasis_csh
		while ( $ii <= $HA_NUM )
			echo "   $HA_TYPE[$ii] $ii $HA_X[$ii] $HA_Y[$ii] $HA_Z[$ii] $HA_OCC[$ii] $HA_B[$ii]" >> $oasis_csh
			@ ii++
		end
	endif
endif

if ( $hl_oasis_signal == 0 && "DMR" != $OASIS_MODE || "DMR" == $OASIS_MODE || $hl_signal == 1) echo "NHL " >> $oasis_csh

if ( ${sigma_signal} == 1 && (-e $sigma_file) ) echo "PHR  " >> $oasis_csh

if ( $COS == "1" ) echo "NFI  " >> $oasis_csh


if ( $CYC != "2" ) echo "CYC $CYC" >> $oasis_csh


#if ( $FOM == "1" ) echo "FOM " >> $oasis_csh

if ( $KMI != "" && $KMI != "auto" ) echo "KMI $KMI" >> $oasis_csh

if ( "SAD" == $OASIS_MODE )  then
	echo "SAD" >> $oasis_csh
endif

if ( "SIR" == $OASIS_MODE )  then
	echo "SIR">> $oasis_csh
endif

if ( "DMR" == $OASIS_MODE ) then
	echo "DMR ">> $oasis_csh
endif
echo "+" >> $oasis_csh
set oasis_out = ${name_c}_oasis.mtz


if ( $hl_oasis_signal == 1  && "DMR" != $OASIS_MODE && $hl_signal == 0 ) then
  set hl_signal = 1
  set hl_file = $oasis_out
  set HLA = HLA
  set HLB = HLB
  set HLC = HLC
  set HLD = HLD
  echo "set hl_file = $hl_file" >> $2
  echo "set hl_signal = 1 " >> $2
  echo "set HLA = HLA" >> $2
  echo "set HLB = HLB" >> $2
  echo "set HLC = HLC" >> $2
  echo "set HLD = HLD" >> $2
endif



########################################################################################
#CAD
########################################################################################
#cad command

set nat_file = $oasis_hklin
if ( $fom_signal == 1 || $hl_signal == 1  ) then
 if ( $OASIS_MODE == "SAD" ) then
  if ( $MAP_FM == "1" )  then 
      echo -n "${CBIN}/cad HKLIN1 $nat_file HKLIN2 $oasis_out " >> $oasis_csh
   else 
      echo -n "${CBIN}/cad HKLIN1 $oasis_out HKLIN2 $oasis_out " >> $oasis_csh
  endif
 else
      echo -n "${CBIN}/cad HKLIN1 $nat_file HKLIN2 $oasis_out " >> $oasis_csh
 endif


@ cad_i = 2

if ( $fom_signal == 1 ) then
	@ cad_i ++
	echo -n "HKLIN${cad_i} $fom_file " >> $oasis_csh
endif

if ( $hl_signal == 1 ) then
	@ cad_i ++
	echo -n "HKLIN${cad_i} $hl_file " >> $oasis_csh
endif



echo -n "HKLOUT ${name_c}_cad.mtz " >> $oasis_csh
echo " << +" >> $oasis_csh
#oasis script
echo		"monitor BRIEF" >> $oasis_csh
echo		"labin file 1 -" >> $oasis_csh
 if ( $OASIS_MODE == "SAD" ) then
  if ( $MAP_FM == "1" )  then 
     echo		    "E1 = $FP -" >> $oasis_csh
     echo		    "E2 = $SIGFP " >> $oasis_csh
   else 
     echo		    "E1 = FP -" >> $oasis_csh
     echo		    "E2 = SIGFP " >> $oasis_csh
  endif
 else
     echo		    "E1 = $FP -" >> $oasis_csh
     echo		    "E2 = $SIGFP " >> $oasis_csh
 endif

echo		"labout file 1 -" >> $oasis_csh
echo		    "E1 = FP -" >> $oasis_csh
echo		    "E2 = SIGFP " >> $oasis_csh
echo		"ctypin file 1 -" >> $oasis_csh
echo		    "E1 = F -" >> $oasis_csh
echo		    "E2 = Q " >> $oasis_csh

echo		"labin file 2 -" >> $oasis_csh
echo	-n    "E1 = PHIB"  >> $oasis_csh

if ( $fom_signal != 1 ) then
	echo " - " >> $oasis_csh
	echo -n "E2 = FOM"  >> $oasis_csh
endif

echo "" >> $oasis_csh

echo	"labout file 2 -" >> $oasis_csh
echo -n "E1 = PHIB"  >> $oasis_csh
if ( $fom_signal != 1 ) then
	echo " - " >> $oasis_csh
	echo -n "E2 = FOM"  >> $oasis_csh
endif
echo "" >> $oasis_csh



echo		"ctypin file 2 -" >> $oasis_csh
echo -n "E1 = P"  >> $oasis_csh
if ( $fom_signal != 1 ) then
	echo " - " >> $oasis_csh
	echo "E2 = W"  >> $oasis_csh
endif
echo "" >> $oasis_csh




@ cad_i = 2
if ( $fom_signal == 1 ) then
	@ cad_i ++
	echo	"labin file ${cad_i} -" >> $oasis_csh
	echo -n "E1 = $FOMM " >> $oasis_csh
	if ( $fof_signal == 1 ) then
	echo " - " >> $oasis_csh
	echo -n "E2 = 2FOFCWT " >> $oasis_csh
	endif 
	echo "" >> $oasis_csh

	echo	"labout file ${cad_i} -" >> $oasis_csh
	echo -n "E1 = FOM " >> $oasis_csh
	if ( $fof_signal == 1 ) then
	echo " - " >> $oasis_csh
	echo -n "E2 = 2FOFCWT " >> $oasis_csh
	endif
	echo "" >> $oasis_csh

	echo		"ctypin file ${cad_i} -" >> $oasis_csh
	echo -n "E1 = W " >> $oasis_csh
	if ( $fof_signal == 1 ) then
	echo " - " >> $oasis_csh
	echo -n "E2 = F " >> $oasis_csh
	endif
	echo "" >> $oasis_csh
endif

if ( $hl_signal == 1 ) then
	@ cad_i ++
	echo	"labin file ${cad_i} -" >> $oasis_csh
	echo "E1 = $HLA -" >> $oasis_csh
	echo "E2 = $HLB -" >> $oasis_csh
	echo "E3 = $HLC -" >> $oasis_csh
	echo "E4 = $HLD " >> $oasis_csh
	echo	"labout file ${cad_i} -" >> $oasis_csh
	echo "E1 = $HLA -" >> $oasis_csh
	echo "E2 = $HLB -" >> $oasis_csh
	echo "E3 = $HLC -" >> $oasis_csh
	echo "E4 = $HLD " >> $oasis_csh
	echo	"ctypin file ${cad_i} -" >> $oasis_csh
	echo "E1 = A -" >> $oasis_csh
	echo "E2 = A -" >> $oasis_csh
	echo "E3 = A -" >> $oasis_csh
	echo "E4 = A " >> $oasis_csh
endif
echo "+" >> $oasis_csh
set oasis_out = ${name_c}_cad.mtz
endif



########################################################################
#SIGMA-A
########################################################################
if ( $OASIS_MODE == "DMR" ) then
  #prepare pdb file
  set sigmaa_pdb = ${name_c}_sigma.pdb
  $oasisbin/frc2pdb.csh $1 $oasis_frc $sigmaa_pdb
  if ( $OASIS_MODE != "DMR" ) then
    set par_n = `awk 'BEGIN{n=0;} {n++} END{print n;}' $oasis_frc `
    awk -v num=$par_n '/^HETATM/{num++;if ( length($3) == 2 ) {printf"%6s%5d%4s%5s%6d%12s%8s%8s%6s%6s%12s\n",$1,num,$3,$4,num,$6,$7,$8,$9,$10,$11; }else{ printf"%6s%5d%3s%4s 1%6d%12s%8s%8s%6s%6s%12s\n",$1,num,$3,$4,num,$7,$8,$9,$10,$11,$12;}  }' $ha_pdb  >> $sigmaa_pdb
  endif
  echo "set sigmaa_pdb = $sigmaa_pdb " >> $2
  set sigmaa_sfall_mtz = ${name_c}_sfall.mtz
  echo "${CBIN}/sfall  HKLIN $oasis_out HKLOUT $sigmaa_sfall_mtz XYZIN $sigmaa_pdb << + " >> $oasis_csh
  echo "LABIN FP=FP SIGFP=SIGFP" >> $oasis_csh
  echo "LABOUT FC=FC PHIC=PHIC" >> $oasis_csh
  echo "MODE SFCALC XYZIN HKLIN " >> $oasis_csh
  echo "symmetry = '$space_name'" >> $oasis_csh
  echo "+" >>  $oasis_csh
  set sigmaa_mtz = ${name_c}_sigmaa.mtz
  echo "${CBIN}/sigmaa HKLIN $sigmaa_sfall_mtz HKLOUT $sigmaa_mtz <<+ " >> $oasis_csh
  echo "LABIN FP=FP SIGFP=SIGFP FC=FC PHIC=PHIC" >> $oasis_csh
  echo "LABOUT DELFWT=DELFWT FWT=FWT WCMB=WCMB" >> $oasis_csh
  echo "ranges  20 1000" >> $oasis_csh
  echo "symmetry = '$space_name'" >> $oasis_csh
  echo "partial damp 1.0" >> $oasis_csh
  echo "+" >> $oasis_csh
  set sigmaa_cad_mtz = ${name_c}_sigmaa_sfall.mtz
  echo "${CBIN}/cad HKLIN1 $oasis_out HKLIN2 $sigmaa_mtz HKLOUT $sigmaa_cad_mtz << +  " >> $oasis_csh
  echo "LABIN FILE 1 ALL" >> $oasis_csh
  echo "LABIN FILE 2 E1=FWT E2=PHIC E3=WCMB" >> $oasis_csh
  echo "+" >> $oasis_csh
  set oasis_out = $sigmaa_cad_mtz
endif






#execute csh
chmod +x $oasis_csh
./$oasis_csh | tee .tmp.log

set average_fom = `awk '/AVERAGE FIGURE OF MERIT/{print $8}' .tmp.log`
rm -f .tmp.log
echo "set average_fom = $average_fom "  >> $2
if ( $OASIS_MODE == "DMR" ) then
  echo "set phase_phi = PHIB  " >> $2
  echo "set phase_fom = WCMB  " >> $2
  echo "set phi = PHIB  " >> $2
  echo "set fom = WCMB  " >> $2
  echo "set fof_signal = 1 " >> $2
  echo "set FOF = FWT" >> $2
else
  echo "set phase_phi = PHIB  " >> $2
  echo "set phase_fom = FOM  " >> $2
  if ( $fof_signal == 1 ) then
    echo "set FOF = 2FOFCWT" >> $2
  endif
  echo "set phi = PHIB  " >> $2
  echo "set fom = FOM  " >> $2
endif



echo "set phase_out = $oasis_out " >> $2

echo "set last_out = $oasis_out " >> $2
echo "set phase_pro = oasis " >> $2
if ( $status != 1 ) then
echo "set phase_status = 1" >> $3
else
echo "set phase_status = 0" >> $3
endif




