####################################################################################
#Author: Zhang Tao
#Email: zhangtao@cryst.iphy.ac.cn
#Created time: 2008,05,20
#last Edit: 2008,05,20
#Group: SM5,  The Institute of Physics, Chinese Academy of Sciences
#####################################################################################

######parameters##################################################
#1: parameters pool
#2: changed parameters pool
#3: states pool
###################################################################################

source $1
source $2

echo "set build_status = 0" >> $3

set phenix_csh = ${name_c}_phenix.csh
rm -f $phenix_csh
touch  $phenix_csh
echo "#\!/bin/bash" >>  $phenix_csh
echo "set -m" >>  $phenix_csh
echo " if [ -e ${name_c}_phenix_tmp ] " >>  $phenix_csh 
echo "then " >>  $phenix_csh
echo "echo 'A phenix_autobuild is running now, please check ${name_c}_phenix_tmp and remove it'" >>  $phenix_csh
echo "else" >>  $phenix_csh
echo "mkdir ${name_c}_phenix_tmp"  >>  $phenix_csh
echo "cd ${name_c}_phenix_tmp" >>  $phenix_csh



if ( $OASIS_MODE == "EXT" ) then
  echo "phenix.autobuild data=$oasis_hklin seq_file=../resolve.seq  \" >>  $phenix_csh
  set labin = "$FP $SIGFP None None" >>  $phenix_csh
else
  if ( $RFREE != 'Unassigned' ) then
    echo "$CBIN/cad HKLIN1 ../$last_out  HKLIN2 $hklin_free  HKLOUT ${name_c}_rfree.mtz << + " >>  $phenix_csh
    echo "LABIN FILE 1 ALL" >>  $phenix_csh
    echo "LABIN FILE 2 E1=$RFREE" >>  $phenix_csh
    echo "+" >> $phenix_csh
    echo "phenix.autobuild data=${name_c}_rfree.mtz  seq_file=../resolve.seq  \" >>  $phenix_csh
  else
    echo "phenix.autobuild data=../$last_out seq_file=../resolve.seq  \" >>  $phenix_csh
  endif
  set labin = "FP SIGFP $phi $fom"
endif
if ( $hl_signal == 1 ) then
  set labin = "${labin} $HLA $HLB $HLC $HLD"
else
  set labin = "${labin} None None None None"
endif

if ( $RFREE == 'Unassigned' ) then
  set labin = "${labin} None"
else
  set labin = "${labin} $RFREE"
endif
  echo -n "input_labels="'"'$labin'"' >>  $phenix_csh

if ( $autobuild_auto_signal == 1 ) then
  echo "  \" >>  $phenix_csh
  echo -n "n_cycle_build_min=$min_build n_cycle_rebuild_min=$min_rebuild" >>  $phenix_csh
endif


if ( $build_second_signal == 1 ) then
  echo "  \" >>  $phenix_csh
  echo -n "helices_strands_only=True" >>  $phenix_csh
endif

if ( $ha_signal == 1 ) then
  echo "  \" >>  $phenix_csh
  echo -n "find_ncs=True  " >>  $phenix_csh
  echo -n "input_ncs_file=../$ha_pdb  " >>  $phenix_csh
  echo -n "input_ha_file=../$ha_pdb" >>  $phenix_csh
endif

if ( $OASIS_MODE == "EXT" ) then
  echo "  \" >>  $phenix_csh
#  echo -n "model=../$init_pdb" >>  $phenix_csh
echo -n "model=$start_pdb" >> $phenix_csh
endif

echo "& " >>  $phenix_csh
echo "sleep 10" >> $phenix_csh 
echo  "tail -F AutoBuild_run_1_/AutoBuild_run_1_1.log & " >> $phenix_csh 
echo  "fg %1 " >>  $phenix_csh
echo  "killall tail" >> $phenix_csh
echo 'best_cyc=`$oasisbin/phenix_select.csh ' " AutoBuild_run_1_/AutoBuild_run_1_1.log $phenix_select_mode"  '`' >>  $phenix_csh
echo "cp  " ' AutoBuild_run_1_/cycle_best_${best_cyc}.pdb ' " ../${name_c}_phenix.pdb" >>  $phenix_csh
echo "cp  " ' AutoBuild_run_1_/cycle_best_${best_cyc}.mtz ' " ../${name_c}_phenix.mtz" >>  $phenix_csh
echo "mv AutoBuild_run_1_ ../${name_c}_phenix" >>  $phenix_csh

echo "cd -" >>  $phenix_csh
echo "rm -fr ${name_c}_phenix_tmp" >>  $phenix_csh
echo "fi" >>  $phenix_csh


#execute csh

if ( -e ${name_c}_phenix_tmp ) then
  rm -fr ${name_c}_phenix_tmp
endif

chmod +x $phenix_csh
./$phenix_csh 

set best_cyc = `$oasisbin/phenix_select.csh ${name_c}_phenix/AutoBuild_run_1_1.log $phenix_select_mode`
set result = `${oasisbin}/phenix_getinf.csh ${name_c}_phenix/AutoBuild_run_1_1.log  $best_cyc `

if ( $result[1] != "" ) then
  echo "set build_status = 1" >> $3
else
  echo "set build_status = 0" >> $3
endif

echo "set recommend = ( $result ) " >> $2
echo "set build_pdb_out = ${name_c}_phenix.pdb" >> $2
echo "set build_mtz_out = ${name_c}_phenix.mtz" >> $2
echo "set build_frc_out = ${name_c}_phenix.frc" >> $2
echo "set build_pro = phenix" >> $2
echo "set fom_signal = 1"  >> $2
echo "set FOMM = FOMM" >> $2
echo "set build_fp = FP " >> $2
echo "set build_sigfp = null " >> $2
echo "set fom_file = ${name_c}_phenix.mtz "  >> $2
#if ( $hl_signal == 1  ) then
#  echo "set hl_signal = 1 " >> $2
#  echo "set hl_file = ${name_c}_phenix.mtz " >> $2
#  echo "set HLA = HLAM" >> $2
#  echo "set HLB = HLBM" >> $2
#  echo "set HLC = HLCM" >> $2
#  echo "set HLD = HLDM" >> $2
#else
#  echo "set hl_signal = 0 " >> $2
#endif
echo "set fof_signal = 0 "  >> $2
source $2
set ncs_tmp = `awk 'BEGIN{n=0;}  /Transformations formatted for input to resolve:/{n++;} END{if ( n>1) n=1;print n;}'  ${name_c}_phenix/overall_best.log`
if ( $ncs_tmp == 1 ) then
set ncs_line = ` awk 'BEGIN{n=0;} /Transformations formatted for input to resolve:/{n++;} END{print n;}' ${name_c}_phenix/overall_best.log`
awk -v line="$ncs_line" 'BEGIN{ m_n=0;n=0;} /rota_matrix|tran_orth|Transformations formatted for input to resolve:/{if ( $1 == "Transformations" ) {n++;next;} if ( n==line ) {print $0;}}' ${name_c}_phenix/overall_best.log > ${name_c}_ncs.log
echo "set ncs_file = ${name_c}_ncs.log"  >> $2
echo "set ncs_signal = 1"   >> $2
endif


${CBIN}/coordconv XYZIN $build_pdb_out \
XYZOUT ${name_c}_tmp.ha  << + > ${name_c}_frc.log
	input PDB -
       orth 1
       output HA
       cell $CELL_A $CELL_B $CELL_C $CELL_ALPHA $CELL_BETA $CELL_GAMMA 
       end
+



awk 'BEGIN{n=0} {n++;c= toupper(substr($2,1,1));c_ha = toupper(substr($2,1,2)) ;if ( c!="C" && c!="N" && c!="O" && c!="S" && c!="D"  ||  c_ha=="SE" || c_ha=="CU"  ) { c=c_ha;} else if ( c =="D" )  { c="C";} printf "%s %d %.4f %.4f %.4f %.4f %.4f \n",c,n,$3,$4,$5,$6,$9;}' ${name_c}_tmp.ha > $build_frc_out

rm -f ${name_c}_tmp.ha

#if ( "1" == $ha_signal )  then
#	set ii = 1
#	set par_n = `awk 'BEGIN{n=0;} {n++} END{print n;}' $build_frc_out `
#	while ( $ii <= $HA_NUM )
#		@ par_n++
#		echo "$HA_TYPE[$ii] $par_n $HA_X[$ii] $HA_Y[$ii] $HA_Z[$ii] $HA_OCC[$ii] $HA_B[$ii]" >> $build_frc_out
#		@ ii++
#	end
#endif


