####################################################################################
#Author: Zhang Tao
#Email: zhangtao@cryst.iphy.ac.cn
#Created time: 2008,05,20
#last Edit: 2008,05,20
#Group: SM5,  The Institute of Physics, Chinese Academy of Sciences
#####################################################################################

######parameters##################################################
#1: parameters pool
#2: changed parameters pool
#3: states pool
###################################################################################

source $1
source $2

echo "set dm_status = 0" >> $3

set resolve_csh = ${name_c}_dm_resolve.csh
rm -f $resolve_csh
touch  $resolve_csh
echo "#\!/bin/tcsh" >>  $resolve_csh
echo " if ( -e ${name_c}_dm_resolve_tmp ) then " >>  $resolve_csh
echo "echo 'A resolve is running now, please check ${name_c}_resolve_tmp and remove it'" >>  $resolve_csh
echo "else" >>  $resolve_csh
echo "mkdir ${name_c}_dm_resolve_tmp"  >>  $resolve_csh
echo "cd ${name_c}_dm_resolve_tmp" >>  $resolve_csh
echo "phenix.resolve << EOD" >>  $resolve_csh
echo "hklin ../$last_out" >>  $resolve_csh
if ( $fof_signal == 1 ) then
  set lab = "FP=$FOF PHIB=$phi FOM=$fom "
else
  set lab = "FP=FP PHIB=$phi FOM=$fom "
endif
if ( $hl_signal == 1 ) then
  set lab = "${lab} HLA=$HLA HLB=$HLB HLC=$HLC HLD=$HLD"
endif

echo "LABIN ${lab}"  >>  $resolve_csh
echo "no_build" >>  $resolve_csh
echo "hklout resolve.mtz" >>  $resolve_csh
echo "solvent_content $SOLC" >>  $resolve_csh
echo "seq_file ../resolve.seq" >>  $resolve_csh
if ( $ha_signal == 1 ) then
  echo "ha_file ../$ha_pdb" >>  $resolve_csh
endif
echo "EOD" >>  $resolve_csh
echo "$CBIN/cad HKLIN1 resolve.mtz HKLOUT ../${name_c}_dm_resolve.mtz<<+" >>  $resolve_csh
echo "LABIN FILE 1 E1=FP E2=SIGFP E3=PHIM E4=FOMM E5=HLAM E6=HLBM E7=HLCM E8=HLDM" >> $resolve_csh
echo "+" >>  $resolve_csh
echo "cd -" >> $resolve_csh
echo "rm -fr ${name_c}_dm_resolve_tmp" >>  $resolve_csh
echo "endif" >>  $resolve_csh


#execute csh
chmod +x $resolve_csh
./$resolve_csh | tee .resolve_tmp.log


echo "set hl_file = ${name_c}_dm_resolve.mtz " >> $2
echo "set HLA = HLAM" >> $2
echo "set HLB = HLBM" >> $2
echo "set HLC = HLCM" >> $2
echo "set HLD = HLDM" >> $2
echo "set dm_phi = PHIM  " >> $2
echo "set dm_fom = FOMM  " >> $2
echo "set dm_out = ${name_c}_dm_resolve.mtz " >> $2
echo "set phi = PHIM  " >> $2
echo "set fom = FOMM  " >> $2
echo "set last_out = ${name_c}_dm_resolve.mtz " >> $2
echo "set dm_pro = resolve" >> $2
if ( $status != 1 ) then
echo "set dm_status = 1" >> $3
else
echo "set dm_status = 0" >> $3
endif


